
//***************** (c) 2012 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : LED
// BOARD    : ZL31ARM and 2 x KAmod LED8
// COMPILER : Keil uVision4.5
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple LEDs demonstration.
//
//    Settings and connections from ZL31ARM to KAmodLED8:
//
//							KAmodLED8 A
//				GND (con1) - KAmodLED8 GND(con1)
//				3.3V(con1) - KAmodLED8 5V (con1)
//        PB8 (con1) - KAmodLED8 D0 (con1)
//        PB9 (con1) - KAmodLED8 D1 (con1)
//        ...
//        PB15 (con1) - KAmodLED8 D7 (con1)
//
//
//							KAmodLED8 B
//				GND (con15) - KAmodLED8 GND(con1)
//				3.3V(con15) - KAmodLED8 5V (con1)
//				PC8 (con15) - KAmodLED8 D0 (con1)
//        PC9 (con15) - KAmodLED8 D1 (con1)
//        ...
//        PC15 (con15) - KAmodLED8 D7 (con1)
//
//******************************************************************************
#include "stm32f10x.h"

void RCC_Config(void);
void GPIO_Config(void);

int main(void)
{
	volatile unsigned long int i;
	volatile unsigned long int LiczDo=150000;
  unsigned int KtoryLEDR=0xAA00;
	unsigned int KtoryLEDG=0x5500;

	bool kierunekLewo=TRUE;

  //konfiguracja systemu
  RCC_Config();   
  GPIO_Config();
		
  while (1) 
	{
																											
		GPIO_Write(GPIOB, KtoryLEDR );         	//ustaw nowa pozycje Wlaczonego LEDa i wstaw mlodsza czesc portu odczytana wczesniej
		GPIO_Write(GPIOC, KtoryLEDG );						//zapisz nowy stan portu

		if (GPIO_ReadInputDataBit(GPIOC,GPIO_Pin_0)==0)			//Odczyt stanu pinu 0 portu C
		{				
			LiczDo=LiczDo-10000;														//Zwieksz predkosc 
			if(LiczDo<200000) LiczDo=200000;								//Ograniczenie maksymalnej predkosci									
		}
		
		if (GPIO_ReadInputDataBit(GPIOC,GPIO_Pin_1)==0)			//Odczyt stanu pinu 1 portu C
		{
			LiczDo=LiczDo+10000;														//Zmniejsz predkosc
			if(LiczDo>700000) LiczDo=700000;								//Ograniczenie minimalnej predkosci		
		}
		
		if (kierunekLewo)																		//jesli w lewo, przesun pozycje w lewo
			{
			KtoryLEDR=KtoryLEDR<<1;                       
			KtoryLEDG=KtoryLEDG>>1;
			
			if (KtoryLEDR>=0x8000)														//jesli dioda 8 - zmien kierunek
			{             			
				kierunekLewo=FALSE;
			}
			} 
			else
			{
				KtoryLEDR=KtoryLEDR>>1;                    		  //jesli w prawo, przesun pozycje w prawo
				KtoryLEDG=KtoryLEDG<<1;	
				
				if (KtoryLEDR<=0x0100)													//jesli dioda 1 - zmien kierunek
				{                        
					kierunekLewo=TRUE;
				}
			}

		for(i=0; i < LiczDo; i++);													//Opoznienie-predkosc LED
				
		if (GPIO_ReadInputDataBit(GPIOB,GPIO_Pin_5)==0)			//Odczyt stanu pinu 5 portu B
		{	
			for(i=0; i < 2500000; i++);											//Opoznienie dla "slow motion"
		}
	}
}

																													
void RCC_Config(void)
{
	//konfigurowanie sygnalow taktujacych
  ErrorStatus HSEStartUpStatus;													 //zmienna opisujaca rezultat uruchomienia HSE

  RCC_DeInit();                                          //Reset ustawien RCC
  RCC_HSEConfig(RCC_HSE_ON);                             //Wlaczenie HSE
  HSEStartUpStatus = RCC_WaitForHSEStartUp();            //Odczekaj az HSE bedzie gotowy
  if(HSEStartUpStatus == SUCCESS)
  {
    FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);
    FLASH_SetLatency(FLASH_Latency_2);                  		    //ustaw zwloke dla pamieci Flash; zaleznie od taktowania rdzenia
																																//0:<24MHz; 1:24~48MHz; 2:>48MHz
    RCC_HCLKConfig(RCC_SYSCLK_Div1);                     				//ustaw HCLK=SYSCLK
    RCC_PCLK2Config(RCC_HCLK_Div1);                      				//ustaw PCLK2=HCLK
    RCC_PCLK1Config(RCC_HCLK_Div2);                      				//ustaw PCLK1=HCLK/2
    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9); 				//ustaw PLLCLK = HSE*9 czyli 8MHz * 9 = 72 MHz
    RCC_PLLCmd(ENABLE);                                 				//wlacz PLL
    while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET);  				//odczekaj na poprawne uruchomienie PLL
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);           				//ustaw PLL jako zrodlo sygnalu zegarowego
    while(RCC_GetSYSCLKSource() != 0x08);                				//odczekaj az PLL bedzie sygnalem zegarowym systemu

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);				//wlacz taktowanie portu GPIO B
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);//wlacz taktowanie portu GPIO C
  } 
	else 
	{
		while(1);
  } 
}




void GPIO_Config(void)
{
  //konfigurowanie portow GPIO
  GPIO_InitTypeDef  GPIO_InitStructure; 

	//Porty wyjsciowe
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_11 | GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;        //wyjscie push-pull
  GPIO_Init(GPIOB, &GPIO_InitStructure);
	GPIO_Init(GPIOC, &GPIO_InitStructure);
	
	//Potrt B pin 5 jako wejsciowy
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING; 	//Wejscie "plywajace"
	GPIO_Init(GPIOB, &GPIO_InitStructure);
	
	//Port C piny 0 oraz 1 jako wejsciowe
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1 ;
	GPIO_Init(GPIOC, &GPIO_InitStructure);
	
		
}
